// Include modules.
var xlsx = require('node-xlsx');
var fs = require('fs');

var chinaGeoCoord = [108.95, 30.27];

var provinceGeoCoord = {
    '甘肃':[103.73, 36.03],
    '青海':[101.74, 36.56],
    '四川':[104.06, 30.67],
    '河北':[114.48, 38.03],
    '云南':[102.73, 25.04],
    '贵州':[106.71, 26.57],
    '湖北':[114.31, 30.52],
    '河南':[113.65, 34.76],
    '山东':[117, 36.65],
    '江苏':[118.78, 32.04],
    '安徽':[117.27, 31.86],
    '浙江':[120.19, 30.26],
    '江西':[115.89, 28.68],
    '福建':[119.3, 26.08],
    '广东':[113.23, 23.16],
    '湖南':[113, 28.21],
    '海南':[110.35, 20.02],
    '辽宁':[123.38, 41.8],
    '吉林':[125.35, 43.88],
    '黑龙江':[126.63, 45.75],
    '山西':[112.53, 37.87],
    '陕西':[108.95, 34.27],
    '台湾':[121.30, 25.03],
    '北京':[116.46, 39.92],
    '上海':[121.48, 31.22],
    '重庆':[106.54, 29.59],
    '天津':[117.2, 39.13],
    '内蒙古':[111.65, 40.82],
    '广西':[108.33, 22.84],
    '西藏':[91.11, 29.97],
    '宁夏':[106.27, 38.47],
    '新疆':[87.68, 43.77],
    '香港':[114.17, 22.28],
    '澳门':[113.54, 22.19]
    };

var colIndexAreaRegionmap = {
    2:'08及以下',
    3:'09-12',
    4:'13-16',
    5:'17-19',
    6:'20-29',
    7:'30-39',
    8:'40-49',
    9:'50-59',
    10:'60-69',
    11:'70及以上'
};

// read xlsx file and analyse
var excelObj = xlsx.parse('OriginalData/ProvinceHouseArea.xls');
var provinceHouseArea = [
    ['国家', '国家经度', '国家纬度', '省', '省经度', '省纬度', '住房面积', '户数', '户数百分比']
];

for (var sheet in excelObj) {
  if (excelObj.hasOwnProperty(sheet)) { // sheet is '0', '1', ...
      var sheetData = excelObj[sheet].data; // data inside a sheet, which is an two-dimention array
      var rowCount = sheetData.length;
      for (var i = 3; i < 35; i++) {
          var rowData = sheetData[i]; // data inside one row, which is an one-dimention array
          
          var columnCount = rowData.length;
          if (columnCount === 0) { return; }

          var provinceName = rowData[0].replace(/\s*/g, '');
          var totalHushu = rowData[1];
          for (var j = 2; j < columnCount; j++) {
            provinceHouseArea.push(['中国', chinaGeoCoord[0], chinaGeoCoord[1], provinceName, provinceGeoCoord[provinceName][0], provinceGeoCoord[provinceName][1], colIndexAreaRegionmap[j], rowData[j], rowData[j]/totalHushu*100.0]);
          }
      }
  }
}

var buffer = xlsx.build([
  {
      name:'sheet1',
      data:provinceHouseArea
  }
  ]);

fs.writeFileSync('ExtractedData/provinceHouseArea.xlsx', buffer, {'flag':'w'}); // 如果文件存在，覆盖